package ru.ulstu.models;

public class Model {
    private TimeSeries originalTimeSeries;
    private TimeSeries modelTimeSeries;

    public Model(TimeSeries originalTimeSeries) {
        this.originalTimeSeries = originalTimeSeries;
        this.modelTimeSeries = new TimeSeries("Model time series of '" + originalTimeSeries.getName() + "'");
    }

    public TimeSeries getOriginalTimeSeries() {
        return originalTimeSeries;
    }

    public TimeSeries getModelTimeSeries() {
        return modelTimeSeries;
    }

    public void addValue(TimeSeriesValue timeSeriesValue) {
        modelTimeSeries.addValue(timeSeriesValue);
    }

    public void addValue(TimeSeriesValue basedOnValue, double value) {
        modelTimeSeries.getValues().add(new TimeSeriesValue(basedOnValue.getDate(), value));
    }
}
