package ru.ulstu.tsMethods.exponential;

import ru.ulstu.models.Forecast;
import ru.ulstu.models.Model;
import ru.ulstu.models.TimeSeries;
import ru.ulstu.tsMethods.TimeSeriesMethod;

public class NoTrendNoSeason extends TimeSeriesMethod {
    private double alpha;

    public NoTrendNoSeason(double alpha) {
        this.alpha = alpha;
    }

    @Override
    protected Model getModelOfValidTimeSeries(TimeSeries timeSeries) {
        Model model = new Model(timeSeries);
        model.addValue(timeSeries.getFirstValue());
        //выполняется проход модели по сглаживанию
        for (int t = 1; t < timeSeries.getValues().size(); t++) {
            model.addValue(timeSeries.getValues().get(t),
                    (1 - alpha) * timeSeries.getNumericValue(t)
                            + alpha * model.getModelTimeSeries().getValues().get(t - 1).getValue());
        }
        return model;
    }

    @Override
    protected Forecast makeForecast(Forecast forecast) {
        forecast.getForecastTimeSeries()
                .getFirstValue()
                .setValue(forecast.getModel().getModelTimeSeries().getLastValue().getValue());
        for (int t = 1; t < forecast.getForecastTimeSeries().getLength(); t++) {
            forecast.getForecastTimeSeries()
                    .getValues()
                    .get(t)
                    .setValue(forecast.getForecastTimeSeries().getValues().get(t - 1).getValue());
        }
        return forecast;
    }
}
